#include "libasus.h"
#include "xf86i2c.h"
#include "i2c.h"

/*  Hopefully this detect routine can be recreated in other projects to expand
    past the limited range of asus cards I plan on supporting 
   
    Hence being in its own file.   
*/

int libasus_detect(I2CDevPtr *card) {
  I2CBusPtr busses[3];

  int bus;
  I2CDevPtr dev;
  char version[5];
  char *s;

  busses[0] = I2cCreateBusPtr("BUS0", 0x2e);  //on riva128 and higher
  busses[1] = I2cCreateBusPtr("BUS1", 0x36);  //on rivatnt hardware and higher
  busses[2] = I2cCreateBusPtr("BUS2", 0x50);  //on geforce4mx and higher but not 
					      //on GF4Ti
  I2CProbeAllDevices(busses, 3);
  
  for (bus = 0; bus < 3; bus++) {
    for (dev = busses[bus]->FirstDev; dev; dev = dev->NextDev) {
      s = NULL;
      dbg_printf("I2C device at address 0x%x\n",dev->SlaveAddr);
      switch (dev->SlaveAddr) {
	case 0x98:
	case 0x6e:
	case 0xa0:
	  break;
        case 0x5a:
	case 0x5c:
	  if (f75375_detect(dev)) {
	    *card = dev;
	    return LIBASUS_DEVICE_F75375;
	  }
	  break;
	default:
	  break;
      }
    }
  }
  return false;
}

// Will allocate the memory if its not done, needs freeing tho
int libasus_create_card(libasus_card *card, I2CDevPtr i2cdev, int type) {
  
  if (card == NULL) {
    card = malloc(sizeof(libasus_card));
  }

  card->card = i2cdev;

  switch (type) {
    case LIBASUS_DEVICE_F75375:
      card->get_gpu_temp = f75375_get_gpu_temp;
      card->get_ram_temp = f75375_get_ram_temp;
      card->get_gpu_fanspeed = f75375_get_gpu_fanspeed;
      card->set_gpu_fanspeed = f75375_set_gpu_fanspeed;

      card->get_gpu_fanmode = f75375_get_gpu_fanmode;
      card->set_gpu_fanmode = f75375_set_gpu_fanmode;
      card->get_gpu_tempctl = f75375_get_gpu_tempctl;
      card->set_gpu_tempctl = f75375_set_gpu_tempctl;
      card->set_gpu_pwmspeed = f75375_set_gpu_pwmspeed;
      card->get_gpu_pwmspeed = f75375_get_gpu_pwmspeed;
      return true;
      break;
    default:
      return false;
  }
}
